# !/usr/bin/env python
# coding=utf-8
# @Time    : 2021/1/5 10:52
# @Author  : 江斌
# @Software: PyCharm

import re
from collections import Counter

boshu = """
《道德经》全文

马王堆出土帛书版

01

道可道也，非恒道也。名可名也，非恒名也。无名万物之始也，有名万物之母也。故：恒无欲也，以观其眇；恒有欲也，以观其徼。两者同出，异名同谓。玄之又玄，众妙之门。

02

天下皆知美之为美，恶矣，皆知善之为善，斯不善矣。有无之相生也，难易之相成也，长短之相形也，高下之相盈也，音声之相和也，先后之相随也。是以圣人居无为之事，行不言之教。万物作而弗始也，为而弗恃也，成功而弗居也，夫唯弗居，是以弗去。

03

不上贤，使民不争。不贵难得之货，使民不为盗。不见可欲，使民不乱。是以圣人之治也，虚其心，实其腹，弱其志，强其骨，恒使民无知无欲也。使夫知不敢弗为而已，则无不治矣。

04

道中，而用之又弗盈也，渊呵，似万物之宗。挫其锐，解其纷，和其光，同其尘，湛呵，似或存。吾不知谁之子，象帝之先。

05

天地不仁，以万物为刍狗。圣人不仁，以百姓为刍狗。天地之间，其犹橐龠舆？虚而不屈，动而愈出。多闻数穷，不若守于中。

06

谷神不死，是谓玄牝。玄牝之门，是谓天地之根。绵绵呵若存，用之不堇。

07

天长地久。天地之所以能长且久者，以其不自生也，故能长生。是以圣人后其身而身先，外其身而身存，不以其无私邪，故能成其私。

08

上善若水。水善利万物而有静，居众人之所恶，故几于道矣。居善地，心善渊，予善天，言善信，政善治，事善能，动善时。夫唯不争，故无尤。

09

持而盈之，不如其已。揣而锐之，不可长葆之。金玉盈室，莫之守也，富贵而骄，自遗咎也。功遂身退，天之道也。

10

营魄抱一，能毋离乎？抟气致柔，能婴儿乎？修除玄览，能无疵乎？爱民治国，能毋以为乎？天门启阖，能为雌乎？明白四达，能毋以知乎？生之，畜之，生而弗有，长而弗宰也，是谓玄德。

11

卅辐同一毂，当其无，有车之用也。埏埴而为器，当其无，有埴器之用也。凿户牖，当其无，有室之用也。故：有之以为利，无之以为用。

12

五色使人之目盲，五音使人之耳聋，五味使人之口爽，驰骋畋猎使人心发狂，难得之货使人之行妨。是以圣人之治也，为腹而不为目，故去彼而取此。

13

宠辱若惊，贵大患若身。何谓宠辱若惊？宠之为下也，得之若惊，失之若惊，是谓宠辱若惊。何谓贵大患若身？吾所以有大患者。为吾有身，及吾无身。有何患？故：贵为身以为天下，若可以托天下矣；爱以身以为天下，汝可以寄天下。

14

视之而弗见，名之曰微。听之而弗，闻名之曰希。搏之而弗得，名之曰夷。三者不可致诘，故混而为一。一者，其上不谬，其下不惚，寻寻呵，不可名也，复归于无物，是谓无状之状，无物之象，是谓沕望。随而不见其后，迎而不见其首。执今之道，以御今之有，以知古始，是谓道纪。更多内容，关注修行圈公众号。

15

古之善为道者，微妙玄达，深不可识。夫唯不可识，故强为之容，曰：与呵，其若冬涉水；犹呵，其若畏四邻；俨呵，其若客；涣呵，其若冰泽；沌呵，其若朴；湷呵，其若浊；旷呵，其若谷。浊而静之徐清，安以动之徐生，保此道者不欲盈，夫唯不欲盈。故能蔽而不成。

16

至虚极也，守静督也，万物旁作，吾以观其复也。夫物芸芸，各复归于其根，归根曰静，静是谓复命。复命常也，知常明也。不知常，妄作凶。知常容，容乃公，公乃王，王乃天，天乃道，道乃久，没身不殆。

17

太上，下知有之，其次亲誉之，其次畏之，其下侮之，信不足，案有不信，猷呵，其贵言也。成功遂事，而百姓谓我自然。

18

故大道废，案有仁义。知慧出，案有大伪。六亲不和，案有孝慈。邦家昏乱，案有贞臣。

19

绝圣弃知，民利百倍。绝仁弃义，民复孝慈。绝巧弃利，盗贼无有。此三言也，以为文未足，故令之有所属：见素抱朴，少思寡欲，绝学无忧。

20

唯与诃，其相去几何？美与恶，其相去何若？人之所畏，亦不可以不畏。恍呵其未央哉。众人熙熙，若享于太牢而春登台。我泊焉未佻，若婴儿之未孩。累呵似无所归，众人皆有余，我独遗，我愚人之心也，惷惷呵。俗人昭昭，我独昏呵，俗人察察，我独闵闵呵，惚呵其若海，恍呵其若无所止。众人皆有以，我独顽以鄙。吾欲独异于人，而贵食母。

21

孔德之容，唯道是从。道之物，唯恍唯惚，惚呵恍呵，中有象呵，望呵惚呵，中有物呵，幽呵冥呵，中有精呵。其精甚真，其中有信。自古及今，其名不去，以顺众父。吾何以知众父之然？以此。

22

炊者不立，自视者不彰，自见者不明，自伐者无功，自矜者不长。其在道也，曰：余食赘行，物或恶之，故有欲者弗居。

23

曲则全，枉则直。洼则盈，敝则新。少则得，多则惑。是以圣人执一，以为天下式。不自视故彰，不自见故明，不自伐故有功，弗矜故能长，夫唯不争，故莫能与之争。古之所谓曲则全者，几虚语哉，诚全归之。

24

希言自然，飘风不终朝，暴雨不终日，孰为此？天地而弗能久，而况于人乎？故从事于道者同于道，德者同于德，失者同于失。同于德者，道亦德之。同于失者，道亦失之。

25

有物混成，先天地生，渊呵寥呵，独立而不改，可以为天地母。吾未知其名，字之曰道，强为之名曰大。大曰逝，逝曰远，远曰反。道大，天大，地大，王亦大。国中有四大，而王居一焉。人法地，地法天，天法道，道法自然。

26

重为轻根，静为躁君，是以君子终日行不离其辎重。虽有阛馆，燕处则昭若。若何万乘之主而以身轻天下？轻则失本，躁则失君。

27

善行者无辙迹，善言者无瑕谪，善数者不以筹策。善闭者无关楗而不可启也，善结者无绳约而不可解也。是以圣人恒善救人而无弃人，物无弃财，是谓袭明。故：善人，善人之师；不善人，善人之资也。不贵其师，不爱其资，虽知乎，大迷也，是谓眇要。

28

知其雄，守其雌，为天下溪；为天下溪，恒德不离；恒德不离，复归于婴儿。知其荣，守其辱，为天下谷；为天下谷，恒德乃足；恒德乃足，复归于朴。知其白守其黑，为天下式；为天下式，恒德不忒；恒德不忒，复归于无极。朴散则为器，圣人用之则为官长，夫大制无割。

29

将欲取天下而为之，吾见其弗得已。夫天下神器也，非可为者也。为者败之，执者失之。物或行或随，或嘘或吹，或强或羸，或培或隳，是以圣人去甚、去大、去奢。

30

以道佐人主，不以兵强于天下，其事好还。师之所居，楚棘生之，善者果而已矣，毋以取强焉。果而勿骄，果而勿矜，果而勿伐，果而不得已居，是谓果而不强。物壮则老，谓之不道，不道早已。

31

夫兵者，不祥之器也，物或恶之，故有欲者弗居。君子居则贵左，用兵则贵右，故兵者非君子之器也。兵者不祥之器也，不得已而用之。铦袭为上，勿美也，若美之，是乐杀人也。夫乐杀人，不可以得志于天下矣。是以吉事上左，丧事上右，是以偏将军居左，上将军居右，言以丧礼居之也。杀人众，以悲哀泣之，战胜，以丧礼处之。

32

道恒无名，朴虽小，而天下弗敢臣，侯王若能守之，万物将自宾，天地相合，以俞甘露，民莫之令而自均焉。始制有名，名亦既有，夫亦将知止，知止所以不殆。俾道之在天下也，犹小谷之于江海也。

33

知人者智也，自知者明也。胜人者有力也，自胜者强也。知足者富也，强行者有志也。不失其所者久也，死而不忘者寿也。

34

道泛呵，其可左右也，成功遂事而弗名有也。万物归焉而弗为主，则恒无欲也，可名于小，万物归焉而弗为主，可名于大。是以圣人之能成大也，以其不为大也，故能成大。

35

执大象，天下往，往而不害，安平泰，乐与饵，过客止。故道之出言也，曰：啖呵其无味也，视之不足见也，听之不足闻也，用之不可既也。

36

将欲歙之，必固张之。将欲弱之，必固强之。将欲去之，必固兴之。将欲夺之，必固与之。是谓微明：柔弱胜刚强，鱼不脱于渊，邦利器不可以示人。

37

道恒无名，侯王若能守之，万物将自化。化而欲作，吾将阗之以无名之朴。阗之以无名之朴，夫将不辱。不辱以静，天地将自正。

38

上德不德是以有德，下德不失德是以无德。上德无为而无以为也，下德为之而有以为，上仁为之而无以为也，上义为之而有以为也，上礼为之而莫之应也则攘臂而扔之。故失道而后德，失德而后仁，失仁而后义，失义而后礼。夫礼者忠信之薄也，而乱之首也，前识者道之华也，而愚之首也，是以大丈夫居其厚而不居其薄，居其实而不居其华，故去彼而取此。

39

昔之得一者，天得一以清，地得一以宁，神得一以灵，谷得一以盈，万物得一以生，侯王得一以为天下正。其致之也：谓天毋已清将恐裂，谓地毋已宁将恐废，谓神毋已灵将恐歇，谓谷毋已盈将恐竭，谓万物毋已生将恐灭，谓侯王毋已贵以高将恐蹶。故必贵而以贱为本，必高而以下为基，夫是以侯王自谓孤、寡、不谷，此其贱之本舆？非也，故致数，舆无舆。是故不欲，禄禄若玉，珞珞若石。

40

上士闻道，堇而行之，中士闻道，若存若亡，下士闻道，大笑之，弗笑，不足以为道，是以建言有之曰：明道如费，进道如退，夷道如类。上德如谷，大白如辱，广德如不足，建德如偷。质真如渝，大方无隅，大器免成，大音希声，天象无形，道褒无名，夫唯道善始且善成。

41

返也者，道之动也；弱也者，道之用也。天下之物生于有，有生于无。

42

道生一，一生二，二生三，三生万物。万物负阴而抱阳，中气以为和。天下之所恶，唯孤、寡、不谷，而王公以自名也，物或损之而益，益之而损，故人之所教兮，议而教人，故强梁者不得死，我将以为学父。

43

天下之至柔，驰骋于天下之至坚，无有入于无间，吾是以知无为之有益也。不言之教，无为之益，天下希能及之矣。

44

名与身孰亲？身与货孰多？得与亡孰病？甚爱必大费，多藏必厚亡，故知足不辱，知止不殆，可以长久。

45

大成若缺，其用不敝。大盈若冲，其用不穷。大直如诎，大巧如拙，大赢如溶。躁胜寒，静胜炅，清静可以为天下正。

46

天下有道，却走马以粪。天下无道，戎马生于郊。罪莫大于可欲，祸莫大于不知足，咎莫憯于欲得。故知足之足，恒足矣。

47

不出于户，以知天下。不窥于牖，以知天道。其出也弥远，其知也弥少，是以圣人不行而知，不见而明，弗为而成。

48

为学者日益，闻道者日损，损之又损，以至于无为。无为而无不为，将欲取天下也恒无事，及其有事也又不足以取天下矣。

49

圣人恒无心，以百姓之心为心。善者善之，不善者亦善之，德善也。信者信之，不信者亦信之，德信也。圣人之在天下，歙歙焉，为天下浑心，百姓皆属耳目焉，圣人皆孩之。

50

出生入死，生之徒十有三，死之徒十有三，而人之生动皆之死地之十有三，夫何故也？以其生生也。盖闻善执生者，陵行不遇兕虎，入军不被甲兵。兕无所揣其角，虎无所措其爪，兵无所容其刃，夫何故也？以其无死地焉。

51

道生之而德畜之，物刑之而器成之，是以万物尊道而贵德，道之尊、德之贵也，夫莫之爵而恒自然也。道，生之、畜之、长之、育之、亭之、毒之、养之、覆之。生而弗有也，为而弗恃也，长而弗宰也，此之谓玄德。

52

天下有始，以为天下母，既得其母，以知其子，既知其子，复守其母，没身不殆。塞其兑，闭其门，终身不堇。启其兑，济其事，终身不救。见常曰明，守柔曰强。用其光，复归其明，毋遗身殃，是谓袭常。

53

使我介然有知也，行于大道，唯施是畏。大道甚夷，民甚好解。朝甚除，田甚芜，仓甚虚；服文采，带利剑，厌食而财货有余，是谓盗夸，盗夸非道也。

54

善建者不拔，善抱者不脱，子孙以祭祀不绝。修之身，其德乃真；修之家，其德有余；修之乡，其德乃长；修之国，其德乃丰；修之于天下，其德乃博。以身观身，以家观家，以乡观乡，以邦观邦，以天下观天下，吾何以知天下然？兹以此。

55

含德之厚者，比于赤子，蜂虿虺蛇弗蜇，攫鸟猛兽弗搏，骨弱筋柔而握固。未知牝牡之合而朘作，精之至也；终日号而不嚘，和之至也。和曰常，知常曰明，益生曰祥，心使气曰强。物壮则老，谓之不道，不道早亡。

56

知者弗言，言者弗知。塞其兑，闭其门，和其光，同其尘，挫其锐，解其纷，是谓玄同。故不可得而亲，不可得而疏，不可得而利，亦不可得而害，不可得而贵，亦不可得而贱，故为天下贵。

57

以正治邦，以奇用兵，以无事取天下。吾何以知其然哉？夫天下多忌讳而民弥贫，人多利器而国家滋昏，民多伎能而奇物滋起，法物滋彰而盗贼多有。是以圣人之言曰：我无为也而民自化，我好静而民自正，我无事而民自富，我欲无欲而民自朴。

58

其政闵闵，其民屯屯，其正察察，其邦缺缺。祸，福之所倚；福，祸之所伏，孰知其极？其无正也，正复为奇，善复为妖。人之悉也，其日固久矣。是以方而不割，兼而不刺，直而不绁，光而不曜。

59

治人事天莫若啬，夫唯啬，是以早服。早服是谓重积德，重积德则无不克，无不克则莫知其极，莫知其极可以有国，有国之母可以长久，是谓根深固氐长生久视之道也。

60

治大国若烹小鲜，以道莅天下。其鬼不神？非其鬼不神也。其神不伤人也？非其神不伤人也，圣人弗伤也。夫两不相伤，故德交归焉。

61

大邦者，下流也，天下之牝也，天下之交也，牝恒以静胜牡，为其静也。故大邦以下小邦则取小国，小邦以下大邦则取于大邦。故或下以取，或下而取。故：大邦者不过欲兼畜人，小邦者不过欲入事人。夫皆得其欲，则大者宜为下。

62

道者万物之主也，善人之宝也，不善人之所葆也。美言可以市，尊行可以贺人。人之不善，何弃之有？故：立天子置三卿，虽有拱之璧以先驷马，不若坐进此道。古之所以贵此道者何也？不谓求以得，有罪以免与？故为天下贵。

63

为无为，事无事，味无味，大小多少，报怨以德。图难乎其易也，为大乎其细也。天下之难作于易，天下之大作于细。是以圣人终不为大，故能成其大。夫轻诺必寡信，多易必多难。是以圣人猷难之，故终于无难。

64

其安也，易持也。其未兆也，易谋也。其脆也，易判也。其微也，易散也。为之于其未有也，治之于其未乱也。合抱之木作于毫末，九尺之台起于蔂土，百仞之高始于足下，为之者败之，执之者失之。是以圣人无为也，故无败也，无执也，故无失也。民之从事也，恒于几成而败之，慎终若始则无败事矣。是以圣人欲不欲而不贵难得之货，学不学而复众人之所过，能辅万物之自然而弗敢为。

65

故曰：为道者非以明民也，将以愚之也。民之难治也，以其知也。故以知知邦，邦之贼也；以不知知邦，邦之德也。恒知此两者，亦稽式也。恒知稽式，此谓玄德。玄德深矣远矣，与物反矣，乃至大顺。

66

江海之所以能为百谷王者，以其善下之也，故能为百谷王。是以圣人之欲上民也，必以其言下之。其欲先民也，必以其身后之。故居前而民弗害也，居上而民弗重也，天下乐推而弗厌也。以其无争，故天下莫能与之争。

67

小邦寡民：使有什佰之器而毋用，使民重死而远徙。有车舟无所乘之，有甲兵无所陈之，使民复结绳而用之。甘其食，美其服，乐其俗，安其居。邻邦相望，鸡犬相闻，民至老死不相往来。

68

信言不美，美言不信。知者不博，博者不知。善者不多，多者不善。圣人无积：既以为人，己愈有；既以予人，己愈多。故：天之道，利而不害；人之道，为而弗争。

69

天下皆谓我大，大而不肖，夫唯肖故能大。若肖久矣，其细也，夫我恒有三宝，持而保之：一曰慈；二曰俭；三曰不敢为天下先。慈故能勇，俭故能广，不敢为天下先故能成事长。今舍其慈且勇，舍其俭且广，舍其后且先，则必死矣。夫慈，以战则胜，以守则固，天将健之如以慈垣之。

70

善为士者不武，善战者不怒，善胜敌者弗与，善用人者为之下，是谓不争之德，是谓用人，是谓配天，古之极也。

71

用兵有言曰：吾不敢为主而为客，吾不进寸而退尺。是谓行无行，攘无臂，执无兵，乃无敌矣。祸莫大于无敌，无敌近亡吾，葆矣。故乘兵相若，则哀者胜矣。

72

吾言甚易知也，甚易行也，而人莫之能知也，而莫之能行也。言有君，事有宗，其唯无知也，是以不我知。知者希，则我贵矣，是以圣人被褐而怀玉。

73

知不知，尚矣。不知不知，病矣。是以圣人之不病，以其病病也，是以不病。

74

民之不畏威，则大威将至矣。毋狎其所居，毋厌其所生。夫唯弗厌，是以不厌。是以圣人自知而不自见也，自爱而不自贵也，故去彼取此。

75

勇于敢者则杀，勇于不敢者则活，此两者或利或害。天之所恶，孰知其故？天之道，不战而善胜，不言而善应，不召而自来，繟然而善谋，天网恢恢，疏而不失。

76

若民恒且不畏死，奈何以杀惧之也？若民恒且畏死，而为畸者吾将得而杀之，夫孰敢矣？若民恒且必畏死，则恒有司杀者。夫代司杀者杀，是代大匠斫也。夫代大匠斫者，稀有不伤其手矣。

77

民之饥也，以其上食税之多也，是以饥。百姓之不治也，以其上之有以为也，是以不治。民之轻死也，以其求生之厚也，是以轻死。夫唯无以生为者，是贤贵生。

78

人之生也柔弱，其死也坚强。万物草木之生也柔脆，其死也枯槁。故曰：坚强者，死之徒也；柔弱微细者，生之徒也。是以兵强则不胜，木强则梗。恒强大居下，柔弱微细居上。

79

天下之道，犹张弓者也。高者抑之，下者举之，有余者损之，不足者补之。故：天之道，损有余而益不足。人之道则不然，损不足而奉有余。孰能有余而有以取奉于天者乎？唯又道者乎？是以圣人为而不恃，功成而不居也。若此，其不欲见贤也。

80

天下莫柔弱于水，而攻坚强者莫之能胜也，以其无以易之也。水之胜刚也，弱之胜强也，天下莫弗知也，而莫之能行也。故圣人之言曰：受邦之垢，是谓社稷之主；受邦之不详是为天下之王。正言若反。

81

和大怨，必有余怨，焉可以为善？是以圣人右介而不以责于人。故有德司介，无德司彻。夫天道无亲，恒与善人。



注：

1.马王堆汉墓出土的帛书《老子》甲、乙本，是距今为止最老的版本。

2.部分帛书版补全文字参考河上公版本。

3.宇宙人生处世养身修心实证悟道觉醒，一书足矣！"""
Daos = {'1': '道可道，非常道 名可名，非常名 无名，天地之始 有名，天地之母 故常无，欲以观其妙 常有，欲以观其缴 此两者同出而异名 同谓之玄 玄之又玄 众妙之门',
        '2': '天下皆知美之为美，斯恶矣 皆知善之为善，斯不善矣 故有无相生，难易相成 长短相形，高下相倾 音声相和，前后相随 是以圣人处无为之事 行不言之教 万物做焉而不辞 生而不有，为而不恃 功成而弗居 夫唯弗居，是以不去',
        '3': '不尚贤，使民不争 不贵难得之货，使民不为盗 不见可欲，使民心不乱 是以圣人之治： 虚其心，实其腹 弱其智，强其骨 常使民无知无欲 使夫智者不敢为也 为无为，则无不治',
        '4': '道冲 而用之或不盈渊兮 似万物之宗 挫其锐 解其纷 和其光 同其尘 湛兮似或存 吾不知谁之子 象帝之先',
        '5': '天地不仁 以万物为刍狗 圣人不仁 以百姓为刍狗 天地之间 其犹橐龠乎 虚而不屈 动而欲出 多言数穷 不如守中',
        '6': '谷神不死 是谓玄牝 玄牝之门 是谓天地根 绵绵若存 用之不勤',
        '7': '天长地久 天地所以能长且久者 以其不自生 故能长生 是以圣人后其身而身先 外其身而身存 非以其无私邪？ 故能成其私。',
        '8': '上善若水 水善利万物而不争 处众人之所恶 故几于道 居善地 心善渊 与善人 言善信 政善治 事善能 动善时 夫唯不争 故无尤',
        '9': '持而盈之 不如其已 揣而锐之 不可常保 金玉满堂 莫知能守 富贵而娇 自遗其咎 功遂身退 天之道',
        '10': '载营魄抱一，能无离乎 专气致柔，能婴儿乎 涤除玄览，能无疵乎 爱民治国，能无为乎 天门开阖，能无雌乎 明白四达，能无知乎 生之畜之 生而不有，为而不恃，长而不宰 是谓玄德',
        '11': '三十辐共一毂 当其无，有车之用 埏埴以为器 当其无，有器之用 凿户牖以为室 当其无，有室之用 有之以为利 无之以为用',
        '12': '五色令人目盲 五音令人耳聋 五味令人口爽 驰骋畋猎另人心发狂 难得之货另人行妨 是以圣人为腹不为目 故去彼取此',
        '13': '宠辱若惊，贵大患若身 何谓宠辱若惊 宠为上，辱为下 得之若惊，失之若惊 是谓宠辱若惊 何谓贵大患若身 吾所以有患，为吾有身 及吾无身，吾有何患 故贵以身为天下，若可寄天下 爱以身为天下，若可托天下',
        '14': '视之不见名曰夷 听之不闻名曰希 搏之不得名曰微 此三者不可致颉 故混而为一 其上不缴 其下不昧 绳绳不可名 夫归于无物 是谓无状之状 无象之象 是谓惚恍 恍兮惚兮 其中有象 惚兮恍兮 其中有物 迎之不见其首 随之不见其后 执古之道 以御今之有 能知古始 是谓道纪',
        '15': '古之善为道者，微妙玄通，深不可识。夫唯不可识，故强为之容： 豫兮若冬涉川 犹兮若畏四邻 俨兮其若客 涣兮其若冰释 敦兮其若朴 旷兮其若谷 混兮其若浊 孰能浊以止 静之徐清 孰能安以久 动之徐生 保此道者不欲盈 夫唯不盈 故能蔽而新成',
        '16': '致虚极 守静笃 万物并作 吾以观复 夫物芸芸 各复归其根 归根曰静 是谓复命 复命曰常 知常曰明 不知常 妄作凶 知常容 容乃公 公乃王 王乃天 天乃道 道乃久没身不殆',
        '17': '太上，不知有之 其次，亲而誉之 其次，畏之 其次，侮之 信不足焉，有不信焉 悠兮，其贵言 功遂事遂 百姓皆谓，我自然',
        '18': '大道废，有仁义 智慧出，有大伪 六亲不和，有孝慈 国家混乱，有忠臣',
        '19': '绝圣弃智 民利百倍绝仁弃义 民复孝慈绝巧弃利 盗贼无有此三者以为文不足故令有所属：见素抱朴 少思寡欲 绝学无忧',
        '20': '唯之于阿 相去几何善之于恶 相去若何人之所畏 不可不畏 荒兮其未央哉 众人熙熙 如享太牢 如春登台 我独泊兮其未兆 如婴儿之未孩 众人皆有余 而我独若遗 我愚人之心也哉 沌沌兮 俗人昭昭 我独昏昏 俗人察察 我独闷闷 湛兮其若海 辽兮若无止 众人皆有以 而我独顽似鄙 我独异于人 而贵食母',
        '21': '孔德之容 唯道是从道之为物 唯恍唯惚 惚兮恍兮 其中有象 恍兮惚兮 其中有物 窈兮冥兮 其中有精 其精甚真 其中有信 自古及今 其名不去 以阅众甫吾 何以知众甫之状哉 以此',
        '22': '曲则全 枉则直 洼则盈 蔽则新 少则得 多则惑 是以圣人抱一为天下式 不自见故明 不自是故彰 不自伐故有功 不自矜故长 夫唯不争 故天下莫能与之争 古之所谓曲则全者 其虚言哉 诚全而归之',
        '23': '希言自然 故飘风不终朝 骤雨不终日 孰为此者 天地 天地尚不能久 而况于人乎 故从事于道者同与道 德者同与德 失者同于失 同于道者道亦乐得之 同于德者德亦乐得之 同于失者失亦乐得之 信不足焉 有不信焉',
        '24': '企者不立 跨者不行 自见者不明 自是者不彰 自伐者无功 自矜者不长 其在道也 曰余食赘形 物或恶之 故有道者不处',
        '25': '有物混成 先天地生 寂兮廖兮 独立不改 周行而不殆 可以为天地母 吾不知其名 字之曰道 强为之名曰大 大曰逝 逝曰远 远曰反 故道大 天大 地大 人亦大 域中有四大 而人居其一焉 人法地 地法天 天法道 道法自然',
        '26': '重为轻根 静为燥君 是以圣人终日行不离缁重 虽有荣观 燕处超然 奈何万乘之主 而以身轻天下 轻则失根 躁则失君',
        '27': '善行无辄迹 善言无瑕谪 善数不用筹策 善闭无关楗不可开 善结无绳约不可解 是以圣人常善救人 故无弃人 常善救物 故无弃物 是谓袭明 故善人者 不善人之师 不善人者 善人之资 不贵其师 不爱其资 虽智大迷 是谓要妙',
        '28': '知其雄 守其雌 为天下溪 为天下溪 常德不离 复归于婴儿 知其白 守其黑 为天下式 为天下式 常德不忒 复归于无极 知其荣 守其辱 为天下谷 为天下谷 常德乃足 复归于朴 朴散则为器 圣人用之 则为官长 故大智不割',
        '29': '将欲取天下而为之 吾见其不得已 天下神器不可为也 不可执也为者败之 执者失之 故物或行或随 或吹或嘘 或强或累 或挫或毁 是以圣人去甚、去奢、其泰',
        '30': '以道佐人主者 不以兵强天下 其事好还 师之所处 荆棘生焉 大军之后 必有凶年 善者果而已 不敢以取强 果而勿矜 果而勿伐 果而勿骄 果而不得已 果而勿强 物壮则老 是谓不道 不道早已。',
        '31': '夫兵者不祥之器 物或勿之 故有道者不处 君子居则贵左 用兵则贵右 兵者不祥之器 非君子之器 胜者不美 而美之者 是乐杀人 夫乐杀人者 则不可得志于天下也 吉事尚左 凶事尚右 偏将军居左 上将军居右 言以丧礼处之 杀人之众以哀悲泣之 战胜以丧礼处之',
        '32': '道常无名，朴虽小 天下莫能臣 侯王若能守之 万物将自宾 天地相合，以降甘露 民莫之令而自均 始制有名，名亦既有 夫亦将知止，知止不殆 譬道之在天下 犹川谷之于江海',
        '33': '知人者智，自知者明 胜人者有力，自胜者强 知足者富，强人者有志 不失其所者久 死而不亡者寿',
        '34': '大道泛兮 其可左右 万物恃之而生而不辞 功成不名有 衣养万物而不为主 可名为小 万物归焉而不为主 可名为大 以其终不为大 故能成其大',
        '35': '执大象 天下往 往而不害 安平泰 乐与耳 过客止 道之出口 淡乎其无味 视之不足见 听之不足闻 用之不足既',
        '36': '将欲歙之，必固张之 将欲弱之，必固强之 将欲废之，必固兴之 将欲夺之，必固与之 是谓微明 柔弱胜刚强 鱼不可脱于渊 国之利器不可以示人',
        '37': '道常无为而无不为 侯王若能守之 万物将自化 化而欲作 吾将镇之以无名之朴 镇之以无名之朴 亦将不欲 不欲以静 天下将自定',
        '38': '上德不德，是以有德 下德不失德，是以无德 上德无为而无以为 下德为之而有以为 上仁为之而无以为 上义为之而有以为 上礼为之而莫之应 则攘臂而扔之 故失道而后德 失德而后仁 失仁而后义 失义而后礼 夫礼者 忠信之薄而乱之首 前始者 道之华而愚之始 是以大丈夫处其厚不居其薄 处其实不居其华 故去彼取此',
        '39': '昔之得一者：天得一以清 地得一以宁神得一以灵 谷得一以盈 万物得一以生 侯王得一以为天下贞 其致之：天无以清将恐裂 地无以宁将恐废 神无以灵将恐歇 谷无以盈将恐竭 万物无以生将恐灭 侯王无以为贞将恐撅 故贵以贱为本 高以下为基 是以侯王自称孤、寡、不谷 此非以贱为本邪？非乎？故至数誉无誉 不欲琭琭如玉 珞珞如石',
        '40': '反者，道之动 弱者，道之用 天下万物生于有 有生于无',
        '41': '上士闻道，勤而行之 中士闻道，若存若亡 下士闻道，大笑之 不笑，不足以为道 故建言有之： 明道若昧 进道若退 夷道若累 上德若谷 大白若辱 广德若不足 建德若偷 质真若渝 大方无隅 大器晚成 大音希声 大象无形 道隐无名 夫唯道，善贷且成',
        '42': '道生一 一生二 二生三 三生万物 万物负阴而抱阳 冲气以为和 人之所恶 孤、寡、不毂 而王公以为称 故物或损之而益 或益之而损 人之所教 我亦教之 强梁者不得其死 吾将以为教父',
        '43': '天下之至柔 驰骋天下之至坚 无有入无间 吾是以知无为之有益 不言之教 无为之益 天下希及之',
        '44': '名与身孰亲 身与货孰多得与亡孰病是以甚爱必大费 多藏必厚亡知足不辱 知之不殆 可以长久',
        '45': '大成若缺 其用不弊大盈若冲 其用不穷大直若屈 大巧若拙 大辩若讷静胜燥 寒胜热清静为天下正',
        '46': '天下有道 却走马以粪 天下无道 戎马生于郊 祸莫大于不知足 咎莫大于欲得 知足之足 常足矣',
        '47': '不出户 知天下不窥有 见天道是以圣人不行而知 不见而名 不为而成',
        '48': '为学日益 为道日损 损之又损 以至于无为 无为而无不为 取天下常以无事 及其有事 不足以取天下',
        '49': '圣人无常心 以百姓心为心善者 吾善之不善者 吾亦善之 德善信者 吾信之不信者 吾亦信之 德信是以圣人在天下歙歙为天下浑其心百姓皆注其耳目 圣人皆孩之',
        '50': '出生入死 生之徒十有三 死之徒十有三 人之生、动之死地亦十有三 夫何故？以其生生之厚 盖闻善摄生者 路行不遇兕虎 入军不被甲兵 兕无所投其角 虎无所用其爪 兵无所容其刃 夫何故？以其无死地',
        '51': '道生之 德蓄之 物形之 势成之是以万物莫不尊道而贵德道之尊 德之贵夫莫之命而常自然故道生之，德蓄之，生之育之，亭之毒之 养之覆之生而不有 为而不恃 长而不宰，是谓玄德',
        '52': '天下有始 以为天下母 既得其母 已知其子 既知其子 复守其母 没身不殆 塞其兑 闭其门 终身不勤 开其兑 济其事 终身不救见小曰明 守柔曰强用其光 复归其明无遗身殃 是以习常',
        '53': '使我介然有知 行于大道 唯施是畏大道甚夷 而民好径朝甚除 田甚芜 苍甚虚服文采 带利剑 厌饮食是谓盗芋非道也哉',
        '54': '善建者不拔 善抱者不脱 子孙以祭祀不辍 修之于身 其德乃真 修之于家 其德乃余 修之于乡 其德乃长 修之于国 其德乃丰 修之于天下 其德乃普 故以身观身 以家观家 以乡观乡 以国观国 以天下观天下 吾何以知天下之然哉？以此',
        '55': '含德之厚，比于赤子 毒虫不蜇 猛兽不据 撅鸟不搏 骨弱筋柔而握固 不知牝牡之合而全作 精之至也 终日号而不嗄 和之至也 知和曰常，知常曰明 益生曰祥，心使气曰强物壮则老 谓之不道 不道早已',
        '56': '知者不言，言者不知 塞其兑，闭其门 挫其锐，解其纷 和其光，同其尘 是谓玄同 故而不可得而亲 不可得而疏 不可得而利 不可得而害 不可得而贵 不可得而贱 故为天下贵',
        '57': '以正治国 以奇用兵 以无事取天下 吾何以知其然哉？ 以此： 天下多忌讳，而民多弥贫 民多利器，国家滋昏 人多伎巧，奇物滋起 法令滋彰，盗贼多有 故圣人曰 我无为而民自化 我好静而民自正 我无事而民自富 我无欲而民自朴',
        '58': '其政闷闷，其民淳淳 其政察察，其民缺缺 祸兮，福之所依 福兮，祸之所伏 孰知其极，其无正 正复为奇，善复为妖 人之迷，其日固久 是以圣人方而不割，廉而不刿，直而不肆，光而不耀',
        '59': '治人事天 莫若啬 夫唯啬，谓之早服 早服是谓重积德 重积德则无不克 无不克则莫知其极 莫知其极可以有国 有国之母可以长久 是谓深根固柢长生久视之道',
        '60': '治大国若烹小鲜 以道莅天下其鬼不神 非其鬼不神其神不伤人 非其神不伤人圣人亦不伤人 夫两不相伤 故德交归焉',
        '61': '大国者下流 天下之交 天下之牝 牝常以静胜牡，以静为下 故大国以下小国 则取小国小国以下大国 则取大国 故或下以取 或下而取 大国不过欲兼蓄人 小国不过欲入事人 夫两者各得其欲 大者益为下',
        '62': '道者 天下之奥善人之宝 不善人之所保美言可以市尊 美行可以加人人之不善 何弃之有？故立天子，置三公 虽拱碧以先驷马 不如座进此道 古之所以贵此道者何？不曰以求得 有罪以免邪？故为天下贵',
        '63': '为无为 事无事 味无味 大小多少 抱怨以德 图难于其易 为大于其细 天下难事必作于易 天下大事必作于细 是以圣人终不为大 故能成其大 夫轻诺必寡信 多易必多难 是以圣人犹难之 故终无难矣',
        '64': '其安易持 其未兆易谋 其脆易泮 其微易散 为之于未有 治之于未乱 合抱之木 生于毫末九层之台 起与垒土千里之行 始于足下为者败之 执者失之 是以圣人无为故无败 无执故无失民之从事 常于几成而败之 慎终如始 则无败事 是以圣人欲不欲 不贵难得之货 学不学 复众人之所过 以辅万物之自然而不敢为',
        '65': '古之善为道者非以明民 将以愚之国之难治 以其多智故以智治国 国之贼不以智治国 国之福知此两者以稽式常知稽式 是谓玄德玄德深矣 远矣 与之反矣然后乃至大顺',
        '66': '江海之所以能为百谷王者以其善下之 故能为百谷王是以欲上民必以言下之欲先民必以身后之是以圣人处上而民不重处前而民不害是以天下乐推而不厌以其不争 故天下莫能与之争',
        '67': '天下皆谓我 道大 似不肖 夫唯大 故似不肖 若肖 久矣其细也夫 我有三宝，持而保之：一曰慈，二曰俭 三曰不敢为天下先 慈故能勇 俭故能广 不敢为天下先故能成器长 今舍慈且勇 舍俭且广 舍后且先 死矣夫慈 以战则胜 以守则固 天将救之 以慈卫之',
        '68': '善为士者不武 善战者不怒善胜敌者不与 善用人者为下是谓不争之德 是为用人之力是谓配天古之极',
        '69': '用兵有言：吾不敢为主而为客不敢进寸而退尺是谓行无行 攘无臂 扔无敌 执无兵祸莫大于轻敌 轻敌几丧吾宝故抗兵相加 哀者胜矣',
        '70': '吾言甚易知 甚易行天下莫能知 莫能行言有宗 事有君夫唯不知 是以不我知知我者希 则我者贵是以圣人披褐怀玉',
        '71': '知不知 上不知知 病圣人不病 以其病病夫唯病病 是以不病',
        '72': '民不畏威 则大威至无狎其所居 无厌其所生夫唯不厌 是以不厌是以圣人自知不自见自爱不自贵故去彼取此',
        '73': '勇于敢 则杀 勇于不敢 则活 此两者 或利或害 天之所恶 孰知其故 是以圣人犹难之 天之道 不争而善胜 不言而善应 不召而自来 繟然而善谋 天网恢恢 疏而不失',
        '74': '民不畏死 奈何以死惧之若使民常畏死 而为奇者吾得执而杀之 孰敢？常有司杀者杀 夫代司杀者杀是谓代打匠斫 夫代大匠斫者希有不伤其手矣',
        '75': '民之饥以其上食税之多 是以饥民之难治以其上之有为 是以难治民之轻死以其上求生之厚 是以轻死夫唯无以生为者是贤于贵生',
        '76': '人之生也柔弱 其死也坚强万物草木之生以柔脆 其死也枯槁故坚强者死之徒 柔弱者生之徒是以兵强则灭 木强则折强大处下 柔弱处上',
        '77': '天之道，其犹张弓欤 高者仰之，下者举之 有余者损之，不足者补之 天之道，损有余而补不足 人之道，则不然，损不足而奉有余 孰能有余以奉天下，唯有道者 是以圣人为而不恃，功成而不处 其不欲见贤也',
        '78': '天下莫柔弱于水 而攻坚强者莫之能胜 其无以易之 弱之胜强，柔之胜刚 天下莫不知，莫能行 是以圣人云 受国之垢，是谓社稷主 受国不祥，是谓天下王 正言若反',
        '79': '和大怨 必有余怨 安可以为善？是以圣人执左契而不责于人 有德司契，无德司彻 天道无亲，常与善人',
        '80': '小国寡民 使有什伯之器而不用 使民重死而不远徙 虽有舟隅，无所乘之 虽有甲兵，无所陈之 使人复结绳而用之 甘其食，美其服 安其居，乐其俗 邻国相望，鸡犬之声相闻 民至老死，不相往来',
        '81': '信言不美，美言不信 善者不辩，辩者不善 知者不博，博者不知 圣人不积 既以与人，己愈有 既以与人，已愈多 天之道，利而不害 圣人之道，为而不争'}


class DaoContent(object):
    def __init__(self):
        self.dao_dict = Daos.copy()

    def get_index_by_word(self, word):
        idxs = []
        for k, v in self.dao_dict.items():
            if word in v:
                idxs.append(k)
        return idxs

    def print_logo(self):
        s = """                             
                                        ##      ##      ####
                                      ####      ##KK    ######
                                  GG######      ####      ##KK
                                      GG##      ####
                                              ##############,,
                                        ######################
                                ..################GG
                                  ####KK      ##WW
                              ..              ##  ..WW####
                    ############            ##  ####WW####
                    ########KK              ##        ####
                    ######                WW##DD####  ####..
                      GG                  ##########  ####,,
                              ii          ######      ####,,
                          ii####          ####        ####GG
                      ########            ##WW  ::jj  ####ff
                      ######            ::##########  ####ii
                      ####              ::######      ####::
                        jj      ##      GG##          ####
                            ,,WW        KK##          ####
                          ######        ##################
                            ######      ########::  LL####
                              ########..
                                ############LL                    ;;tt######
                                  ..########################################
                                      ..##################################
                                            ##########################EE
                                                  ##################LL

        """
        new_s = ''
        # for line in s.split('\n'):
        #     for c in line:
        #         new_s += (c + c)
        #     new_s += '\n'
        print(s)

    def print_help(self):
        print(f"""
        使用说明：
            c: 查找某一章节。例如，查找第10章：c 10。
            s: 查找某一字词。例如，查找所有出现“道”字的章节：s 道。
            e: 退出。
            h: 打印帮助。
        """)

    def search_word(self, word):
        repeat_time = 0
        sentences = []
        for k, v in self.dao_dict.items():
            if word in v:
                sub_repeat_time = len(re.findall(word, v))
                repeat_time = repeat_time + sub_repeat_time
                sentences.append((k, v))
        chapters = [int(each[0]) for each in sentences]
        print(f'出现章节：【{len(chapters)}】{repeat_time}\n'
              f'出现总次数：{chapters}')
        for chapter_id, chapter_content in sentences:
            sub_repeat_time = len(re.findall(word, chapter_content))
            chapter_content = chapter_content.replace(word, f'【{word}】')
            print(f"第{chapter_id}章({sub_repeat_time}) {chapter_content}\n")
        # return repeat_time, sentences

    def summary(self):
        content = ''.join(self.dao_dict.values())
        content = content.replace(' ', '').replace('，', '').replace('？', '')
        counter = Counter(content)
        n = 100
        for item in counter.most_common(n):
            print(item)

    def run(self):
        self.print_logo()
        while True:
            input_content = input("\n输入命令(c, s, e, h)：")
            parts = input_content.split(' ', 2)
            if len(parts) == 2:
                cmd = parts[0]
                cmd_content = parts[1]
                if cmd == 'c':
                    result = self.dao_dict.get(cmd_content.strip(), '未找到')
                    print(result)
                    continue
                if cmd == 's':
                    self.search_word(cmd_content.strip())
                    continue
                if cmd == 'h':
                    self.print_help()
                if cmd == 'l':
                    d = {
                        "柔": []
                    }
                else:
                    print("未知命令。")
                    self.print_help()

            else:
                if input_content == 'e':
                    break
                print("未知命令。")
                self.print_help()


if __name__ == '__main__':
    dao = DaoContent()
    # dao.search_word('道')
    # dao.search_word('德')
    # dao.summary()
    # dao.search_word('')
    dao.run()
